#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <algorithm>

#define LEFT 0
#define RIGHT 1
#define VERTICAL 2
#define HORIZONTAL 3
#define DIAGONAL 4
#define ANTI_DIAGONAL 5

std::map<char, std::string> nieco;

void vertical(std::vector< std::string >& vec)
{
	unsigned int size = vec.size();
	for ( unsigned int i =0; i<size; i++)
	{
		for ( unsigned int j = 0; j <size; j++ )
		{
			vec[i][j] = nieco[vec[i][j]] [VERTICAL];
		}
		std::reverse(vec[i].begin(), vec[i].end());
	}
}

void horizontal(std::vector< std::string >& vec)
{
	unsigned int size = vec.size();
	for ( unsigned int i =0; i<size; i++)
	{
		for ( unsigned int j = 0; j <size; j++ )
		{
			vec[i][j] = nieco[vec[i][j]] [HORIZONTAL];
		}
	}
	for ( unsigned int i =0; i<size / 2; i++){
		std::swap(vec[i], vec[size - i - 1]);
	}
}

void left(std::vector< std::string >& vec)
{
	std::vector < std::string > copy = vec;

	unsigned int size = vec.size();
	for ( unsigned int i =0; i<size; i++)
	{
		for ( unsigned int j = 0; j <size; j++ )
		{
			vec[size - j - 1][i] = nieco[copy[i][j]] [LEFT];
		}
	}
}

void right(std::vector< std::string >& vec)
{
	std::vector < std::string > copy = vec;

	unsigned int size = vec.size();
	for ( unsigned int i =0; i<size; i++)
	{
		for ( unsigned int j = 0; j <size; j++ )
		{
			vec[j][size - i - 1] = nieco[copy[i][j]] [RIGHT];
		}
	}
}

void diagonal(std::vector< std::string >& vec)
{
	right(vec);
	vertical(vec);
}

void anti_diagonal(std::vector< std::string >& vec)
{
	left(vec);
	vertical(vec);
}

int main()
{
	std::vector < std::string > vec;	
	
	nieco['<'] = "v^><^v";
	nieco['>'] = "^v<>v^";
	nieco['^'] = "<>^v<>";
	nieco['v'] = "><v^><";
	nieco['o'] = "oooooo";
	nieco['x'] = "xxxxxx";
	nieco['/'] = "\\\\\\\\//";
	nieco['\\'] = "////\\\\";
	nieco['|'] = "--||--";
	nieco['-'] = "||--||";

	int n;
	while (std::cin >> n){
		vec.resize(n);
		
		for (int i = 0; i < n; i++){
			std::cin >> vec[i];

		}

		std::string line;
		line.reserve(2000000);
		std::getline(std::cin, line);
		std::getline(std::cin, line);

		int direction = 0;
		bool back = false;
		for(unsigned int j = 0; j < line.size(); j+=2){
			switch(line[j]){
				case'|':
					if (direction == 1) direction = 3;
					else if (direction == 3) direction = 1;
					back = !back;
				break;
				case'-':
					if (direction == 0) direction = 2;
					else if (direction == 2) direction = 0;
					back = !back;
				break;
				case'<':
					direction = (direction + 3) % 4;
				break;
				case'>':
					direction = (direction + 1) % 4;
				break;
				case'\\':
					direction = (direction + 1) % 4;
					if (direction == 1) direction = 3;
					else if (direction == 3) direction = 1;
					back = !back;
				break;
				case'/':
					direction = (direction + 3) % 4;
					if (direction == 1) direction = 3;
					else if (direction == 3) direction = 1;
					back = !back;
				break;
			}
		}
		// Output

		if (back) vertical(vec);
		for(int i = 0; i < direction; i++){
				right(vec);
			}

		for ( unsigned int j = 0; j<vec.size(); j++)
			std::cout << vec[j] << std::endl;	
	}
}
